{$F+}
Unit
	Terminal; { Polit Halcyon TERMINAL application }

Interface

Uses
	Kernel, Types, D, Ctl, Ctl2, Gfx, dos,

    Interp;

Type
	TMemoTestData=Record
		MemTest: PControl;
		btnNew, InpName: PControl;
                q:TInterpProg;
                u:boolean;
                status:byte; {0:not run; 1:run not input; 2:run and input;}
 	End;

Implementation



Procedure OnPaint(Me:PProg);
Begin
	With Me^, ClientRect, TMemoTestData(Data^) Do
	Begin

                 if status=0 then
                   Button_SetCaption(BtnNew, 'Stopped')
                 else if status=1 then
                   Button_SetCaption(BtnNew, 'Running')
                 else if status=2 then
                   Button_SetCaption(BtnNew, 'Input')
                 else
                   Button_SetCaption(BtnNew, '???');

{                if status>0 then}
                  Ctl2.Memo_Paint(MemTest, 5, 5, X2-X1-5, Y2-Y1-35);
{                if (status=2) or (status=0) then}
                  begin
        		Ctl.Button_Paint(BtnNew, X2-X1-35, Y2-Y1-25, X2-X1-7);
	        	Ctl.InpLine_Paint(InpName, 5, Y2-Y1-25, X2-X1-43);
                  end;
{                if status=2 then status:=1;}
 	End;
End;

Procedure OnNewBtn(Me:PProg;Control:PControl);
var text_in_edit : String;
    vlog : text;
Begin
    With Me^, TMemoTestData(Data^) Do
	Begin
           if status=0 then
             begin
              text_in_edit:=InpLine_GetText(InpName);
              q.InitExecFile(text_in_edit);
              status:=1;
             end
           else if status=2 then
             begin
               text_in_edit:=InpLine_GetText(InpName);
               q.resultInput:=text_in_edit;
               q.waitingForInput:=false;
               q.EndOfOperatorInput;
             end;
	   Ctl2.Memo_loadfile(MemTest,'term.log',true);
	   if status<>1 then Kernel.SelectFocusCtl(Me, InpName);

           PaintWindow(Me);
	End;

End;

Procedure OnClose(Me:PProg);
Begin
	FreeMem(Me^.Data, SizeOf(TMemoTestData))
End;


Procedure OnIdle(Me:PProg);
var
   f:text;
Begin
	With Me^, TMemoTestData(Data^) Do
	Begin
		{ i  i筮,  i  ⨩ i稬 i訬          }
		{   㭮 ஡ ⮧i (ࠫ쭠 ஡ ணࠬ)   }
		{  ⢮ ணࠬ   ஡ i, " 䮭i" -    }
		{ ० -   楤  i쮢㢠 类 袨   }
              if status<>0 then
                if (q.isRunning) and not q.waitingForInput then
                 begin
                   q.NextOperator;
                   Ctl2.Memo_loadfile(MemTest,'term.log',true);
{                   if q.IsRunning then
                     begin
                       assign(f, 'term.log');
                       append(f);
                       writeln(f, 'Next operator');
                       close(f);
                       Ctl2.Memo_loadfile(MemTest,'term.log',true);
                     end;}
                   if not q.IsRunning then
                     begin
                       status:=0;
                       assign(f, 'term.log');
                       append(f);
                       writeln(f, 'Program ended');
                       close(f);
                       Ctl2.Memo_loadfile(MemTest,'term.log',true);
                     end;
                   if q.fatalError then
                     begin
                       q.IsRunning:=false;
                       assign(f, 'term.log');
                       append(f);
                       writeln(f, q.errorStr);
                       close(f);
                       Ctl2.Memo_loadfile(MemTest,'term.log',true);
                     end;
                   if q.waitingForInput then
                     begin
                       status:=2;
                     end;
                   if q.isOutput then
                     begin
                          Ctl2.Memo_loadfile(MemTest,'term.log',true);
                          q.isOutput:=false;
                     end;
                 end;
	End
End;


Procedure OnInit(Me:PProg);
var
        f:text;
Begin
        assign(f,'term.log');
        rewrite(f);
        writeln(f,'samlpe');
        close(f);
	Me^.OnPaint:=OnPaint;
	Me^.OnClose:=OnClose;
	Me^.OnIdle:=OnIdle;
	With Me^ Do
	Begin
		D.AssignPStr('PolitPascal build 1.23', WinTitle);
		MinX:=320;
		MinY:=200;
		GetMem(Data, SizeOf(TMemoTestData));
		Kernel.InitWindow(Me, 'BlueWin', [wbMin, wbMax, wbClose]);
		Kernel.DrawWindow(Me);

		With TMemoTestData(Data^) Do
		Begin
                        status:=0;

			MemTest:=Ctl2.Memo_Create(Me, mkReadOnly, True, '');
{			Memo_SetFont(MemTest, FontDoslike);}
			InpName:=Ctl.InpLine_Create(Me, '1.pas', nil);
			BtnNew:=Ctl.Button_Create(Me, 'Run', nil, ppLeft, OnNewBtn);
			ActiveCtl:=InpName;
			ButtonEnter:=BtnNew;
                        q.IsRunning:=false;
		End;
	End;
End;



Begin
	Kernel.RegBuiltIn('Terminal','Terminal', 'pic\i_term.bmp', OnInit)
End.
